#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

int add_HG(struct HairGuide *srcHG, struct HG_List *HGL ) ;

#define POINT_NUM  (3*2+1)
#define GEN_STEP   (0.3)

int gen_HG( struct PolyObjData *Poly, struct HG_List *HGL, int gid )
{
  int i,j ;
  struct HairGuide HG ;

  if( gid<0 || gid>=GPNUM ) return(-1) ;
  for( i=0 ; i<Poly->pnum ; i++ ){
    if( Poly->sel[i]!=0 ){
      HG.type=0  ;
      HG.pnum =POINT_NUM*3 ;
      HG.nknot=8 ;
      HG.sel  =1 ;
      HG.gid  =gid ;
      HG.pid  =i ;
      HG.rp   =Poly->plist[i] ;
      HG.rn   =Poly->nlist[i] ;
      for( j=0 ; j<HG.nknot ; j++ ){
	if( j<HG.nknot/2 ){
	  HG.knots[j]=0.0 ;
	}else{
	  HG.knots[j]=1.0 ;
	}
      }
      for( j=0 ; j<POINT_NUM ; j++ ){
	HG.plist[j*3+0]=Poly->plist[i].x + Poly->nlist[i].x*j*GEN_STEP ;
	HG.plist[j*3+1]=Poly->plist[i].y + Poly->nlist[i].y*j*GEN_STEP ;
	HG.plist[j*3+2]=Poly->plist[i].z + Poly->nlist[i].z*j*GEN_STEP ;
      }

      add_HG(&HG,HGL) ;

      free(HG.plist) ;
      free(HG.knots) ;
    }
  }
  return(0) ;
}

int add_HG(struct HairGuide *srcHG, struct HG_List *HGL )
{
  int ad ;

  ad=HGL->n ;
  if( ad >= HGL->max ){
    return(-1) ;
  }

  memcpy( &HGL->HG[ad], srcHG, sizeof(struct HairGuide) ) ;
  HGL->n++ ;

  return(0) ;
}
  
int del_HG( struct HG_List *HGL )
{
  int i,j ;

  j=0 ;
  for( i=0 ; i<HGL->n ; i++ ){
    if( HGL->HG[i].sel==0 ){
      memcpy( &HGL->HG[j], &HGL->HG[i], sizeof(struct HairGuide) ) ;
      j++ ;
    }
  }
  for( i=0 ; i<(HGL->n-j) ; i++ ){
    free(HGL->HG[i+j].plist) ;
    free(HGL->HG[i+j].knots) ;

  }

  HGL->n = j ;

  return(0) ;
}
    
  
int chg_HGgid( struct PolyObjData *Poly, struct HG_List *HGL, int gid )
{
  int i ;

  if( gid<0 || gid>=GPNUM ) return(-1) ;
  
  for( i=0 ; i<HGL->n ; i++ ){
    if( HGL->HG[i].sel!=0 ){
      HGL->HG[i].gid=gid ;
    }
  }

  return(0) ;
}
  
