#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

struct element_HG search_HG( struct View3D *view3d, struct HG_List *HGL )
{
  struct Vec3D cur ;
  struct Vec3D eye ;
  struct Vec3D ray ;
  struct Vec3D nray ;
  struct Vec3D x_axis ;
  struct Vec3D y_axis ;
  int i,j ;
  double threshold ;
  int found ;
  struct element_HG element ;
  double minimum ;
  
  threshold=0.05 ;
  element.n=-1 ;
  minimum=threshold ;
  x_axis.x=1.0 ; x_axis.y=0.0 ; x_axis.z=0.0 ;
  y_axis.x=0.0 ; y_axis.y=1.0 ; y_axis.z=0.0 ;

  eye=view3d->v ;
  cur=view3d->cur ;

  SubVec( &eye, &view3d->p, &eye ) ;
  SubVec( &cur, &view3d->p, &cur ) ;
  RotateVec( &eye, view3d->r.x, &x_axis ) ;
  RotateVec( &eye, view3d->r.y, &y_axis ) ;
  RotateVec( &cur, view3d->r.x, &x_axis ) ;
  RotateVec( &cur, view3d->r.y, &y_axis ) ;

  SubVec( &cur, &eye, &ray ) ;
  NormalizeVec( &ray, &nray ) ;

  //printf("ray_x=%f ray_y=%f ray_z=%f\n",ray.x,ray.y,ray.z) ;
  found=0 ;
  for( i=0 ; i<HGL->n ; i++ ){
    for( j=0 ; j<HGL->HG[i].pnum ; j+=3 ){
      struct Vec3D pvec ;
      struct Vec3D qvec ;
      struct Vec3D dvec ;
      double dist ;

      pvec.x=HGL->HG[i].plist[j+0] ;
      pvec.y=HGL->HG[i].plist[j+1] ;
      pvec.z=HGL->HG[i].plist[j+2] ;
      SubVec( &pvec, &eye, &pvec ) ;
      
      dist = DotProduct(&pvec,&ray)/LengthVec(&ray) ;
      if( dist<0.0 ) continue ;

      ScaleVec( &nray, dist, &qvec ) ;
      SubVec( &qvec, &pvec, &dvec ) ;
      //	printf("i=%d,j=%d\n",i,j) ;
      //	printf("p_x=%f p_y=%f p_z=%f\n",pvec.x,pvec.y,pvec.z) ;
      //	printf("n_x=%f n_y=%f n_z=%f\n",nray.x,nray.y,nray.z) ;
      //	printf("leng=%f\n",LengthVec(&qvec)) ;
      dist = LengthVec(&dvec) ;
      if( dist<threshold ){
	if( view3d->gp[HGL->HG[i].gid].hide==0 ){ /** $BHsI=<($N>l9g$OA*BrBP>]$K$J$i$J$$(B **/
	  if( found==0 ){
	    minimum=dist ;
	    element.n=i ;
	    element.p=j/3 ;
	    found=1 ;
	    view3d->scale=LengthVec(&qvec)/LengthVec(&ray) ;
	  }else{
	    if( minimum > dist ){
	      minimum=dist ;
	      element.n=i ;
	      element.p=j/3 ;
	      view3d->scale=LengthVec(&qvec)/LengthVec(&ray) ;
	    }
	  }
	}
      }
    }
  }
  view3d->HGno=element ;
  return(element) ;
}
  
