/********************************************************************************
  search HairRoot($BLS:,(B)
********************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "vector.h"
#include "obj.h"

int search_HR( struct View3D *view3d, struct PolyObjData *Poly)
{
  struct Vec3D cur ;
  struct Vec3D eye ;
  struct Vec3D ray ;
  struct Vec3D nray ;
  struct Vec3D x_axis ;
  struct Vec3D y_axis ;
  int i ;
  double threshold ;
  int found ;
  int element ;
  double minimum ;
  
  threshold=0.05 ;
  element  =-1 ;
  minimum=threshold ;
  x_axis.x=1.0 ; x_axis.y=0.0 ; x_axis.z=0.0 ;
  y_axis.x=0.0 ; y_axis.y=1.0 ; y_axis.z=0.0 ;

  eye=view3d->v ;
  cur=view3d->cur ;
  
  SubVec( &eye, &view3d->p, &eye ) ;
  SubVec( &cur, &view3d->p, &cur ) ;
  RotateVec( &eye, view3d->r.x, &x_axis ) ;
  RotateVec( &eye, view3d->r.y, &y_axis ) ;
  RotateVec( &cur, view3d->r.x, &x_axis ) ;
  RotateVec( &cur, view3d->r.y, &y_axis ) ;

  SubVec( &cur, &eye, &ray ) ;
  NormalizeVec( &ray, &nray ) ;

  found=0 ;
  for( i=0 ; i<Poly->pnum ; i++ ){
    struct Vec3D pvec ;
    struct Vec3D qvec ;
    struct Vec3D dvec ;
    double dist ;

    if( Poly->draw[i]==0 ) continue ;
    
    pvec.x=Poly->plist[i].x ;
    pvec.y=Poly->plist[i].y ;
    pvec.z=Poly->plist[i].z ;
    SubVec( &pvec, &eye, &pvec ) ;
    
    dist = DotProduct(&pvec,&ray)/LengthVec(&ray) ;
    if( dist<0.0 ) continue ;
    
    ScaleVec( &nray, dist, &qvec ) ;
    SubVec( &qvec, &pvec, &dvec ) ;
    dist = LengthVec(&dvec) ;
    if( dist<threshold ){
      if( found==0 ){
	minimum=dist ;
	element=i ;
	found=1 ;
	view3d->scale=LengthVec(&qvec)/LengthVec(&ray) ;
      }else{
	if( minimum > dist ){
	  minimum=dist ;
	  element=i ;
	  view3d->scale=LengthVec(&qvec)/LengthVec(&ray) ;
	}
      }
    }
  }
  view3d->HRno=element ;
  return(element) ;
}
  
