/*
 *  OpenGLg^
 */
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "gluw.h"
#include "vector.h"
#include "obj.h"
#include "hair.h"
#include "resource.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
int win_command(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) ;

char szClassName[] = "WinGL"; //EBhENX
HINSTANCE hInst;              //CX^Xnh
HWND hMain;

HGLRC hRC;

int keycount=0 ;

int __GLUW_mouseX ;
int __GLUW_mouseY ;
int __GLUW_mouseB ;
int __GLUW_ACS_keystat ; /** ALT/CNTL/SHIFT key stat **/

int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,
		   LPSTR lpsCmdLine, int nCmdShow)
{
  MSG msg;
  BOOL bRet;
  HACCEL hAccel;
  
  __GLUW_mouseX=0 ;
  __GLUW_mouseY=0 ;
  __GLUW_mouseB=0 ;
  __GLUW_ACS_keystat=0 ;
  
  hInst = hCurInst; //O[oϐɃCX^XnhRs[
  if (!InitApp(hCurInst)) return FALSE;
  if (!InitInstance(hCurInst, nCmdShow)) return FALSE;
  hAccel = LoadAccelerators(hCurInst, "MYACCEL");
  while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) {
    if (bRet == -1) {
      break;
    } else {
      if (!TranslateAccelerator(hMain, hAccel, &msg)) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
      }
    }
  }
  return (int)msg.wParam;
}

//EBhEENX̓o^

ATOM InitApp(HINSTANCE hInst)
{
  WNDCLASSEX wc;
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = WndProc;	//vV[W
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInst;//CX^X
  wc.hIcon = (HICON)LoadImage(NULL,
			      MAKEINTRESOURCE(IDI_APPLICATION),
			      IMAGE_ICON,
			      0,
			      0,
			      LR_DEFAULTSIZE | LR_SHARED);
  wc.hCursor = (HCURSOR)LoadImage(NULL,
				  MAKEINTRESOURCE(IDC_ARROW),
				  IMAGE_CURSOR,
				  0,
				  0,
				  LR_DEFAULTSIZE | LR_SHARED);
  wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = "MYMENU";	//j[
  wc.lpszClassName = (LPCSTR)szClassName;
  wc.hIconSm = (HICON)LoadImage(NULL,
				MAKEINTRESOURCE(IDI_APPLICATION),
				IMAGE_ICON,
				0,
				0,
				LR_DEFAULTSIZE | LR_SHARED);
  
  return (RegisterClassEx(&wc));
}

//EBhE̐

BOOL InitInstance(HINSTANCE hInst, int nCmdShow)
{
  HWND hWnd;
  
  hWnd = CreateWindow(szClassName,
		      "WinGL test", //^Cgo[ɂ̖O\܂
		      WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_OVERLAPPEDWINDOW, //EBhE̎
		      CW_USEDEFAULT,	//wW
		      CW_USEDEFAULT,	//xW
		      CW_USEDEFAULT,	//
		      CW_USEDEFAULT,	//
		      NULL, //eEBhẼnhAeƂNULL
		      NULL, //j[nhANXj[gƂNULL
		      hInst, //CX^Xnh
		      NULL);
  if (!hWnd) return FALSE;
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  hMain = hWnd;
  return TRUE;
}

//EBhEvV[W

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
  static HMENU hMenu;
  static HDC   WinDC;
  int pixelFormat;
  
  PIXELFORMATDESCRIPTOR pfd = { 
    sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd 
    1,                     // version number 
    PFD_DRAW_TO_WINDOW |   // support window 
    PFD_SUPPORT_OPENGL |   // support OpenGL 
    PFD_DOUBLEBUFFER,      // double buffered 
    PFD_TYPE_RGBA,         // RGBA type 
    24,                    // 24-bit color depth 
    0, 0, 0, 0, 0, 0,      // color bits ignored 
    0,                     // no alpha buffer 
    0,                     // shift bit ignored 
    0,                     // no accumulation buffer 
    0, 0, 0, 0,            // accum bits ignored 
    32,                    // 32-bit z-buffer 
    0,                     // no stencil buffer 
    0,                     // no auxiliary buffer 
    PFD_MAIN_PLANE,        // main layer 
    0,                     // reserved 
    0, 0, 0                // layer masks ignored 
  }; 

  switch (msg) {
  case WM_CREATE:
    hMenu = GetMenu(hWnd);
    
    WinDC=GetDC(hWnd);
    pixelFormat = ChoosePixelFormat(WinDC,&pfd);
    SetPixelFormat(WinDC,pixelFormat,&pfd);
    hRC=wglCreateContext(WinDC);
    wglMakeCurrent(WinDC,hRC);

    sys_init() ;
    gluw_init() ;
  
    printf("WM_CREATE\n") ;
    break;
    
  case WM_INITMENU:
    DrawMenuBar(hWnd);
    printf("WM_INITMENU\n") ;
    break;
    
  case WM_PAINT:
    {
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hWnd, &ps);
      EndPaint(hWnd, &ps);
      gluw_display() ;
      SwapBuffers(GetDC(hWnd));
    }
    break;
    
  case WM_SIZE:
    {
      int w=LOWORD(lp) ;
      int h=HIWORD(lp) ;
      
      gluw_reshape(w,h) ;
    }
    break;

  case WM_LBUTTONDOWN:
  case WM_LBUTTONUP:
  case WM_LBUTTONDBLCLK:
  case WM_RBUTTONDOWN:
  case WM_RBUTTONUP:
  case WM_RBUTTONDBLCLK:
  case WM_MOUSEMOVE:
    {
      __GLUW_mouseX=LOWORD(lp) ;
      __GLUW_mouseY=HIWORD(lp) ;
      if( msg==WM_MOUSEMOVE ){
      }else{
	__GLUW_mouseB=0 ;
	switch( msg ){
	case WM_LBUTTONDOWN:
	  __GLUW_mouseB|=GLUW_LBUTTONDOWN ;
	  break ;
	case WM_LBUTTONUP:
	  __GLUW_mouseB|=GLUW_LBUTTONUP ;
	  break ;
	case WM_LBUTTONDBLCLK:
	  __GLUW_mouseB|=GLUW_LBUTTONDBLCLK ;
	  break ;
	case WM_RBUTTONDOWN:
	  __GLUW_mouseB|=GLUW_RBUTTONDOWN ;
	  break ;
	case WM_RBUTTONUP:
	  __GLUW_mouseB|=GLUW_RBUTTONUP ;
	  break ;
	case WM_RBUTTONDBLCLK:
	  __GLUW_mouseB|=GLUW_RBUTTONDBLCLK ;
	  break ;
	default :
	  return (DefWindowProc(hWnd, msg, wp, lp));
	  break ;
	}
      }
      if (GetKeyState(VK_SHIFT) < 0){
      	__GLUW_ACS_keystat|=GLUW_SHIFT_KEY ;
      }else{
      	__GLUW_ACS_keystat&=~(GLUW_SHIFT_KEY) ;
      }
      if (GetKeyState(VK_CONTROL) < 0){
      	__GLUW_ACS_keystat|=GLUW_CNTL_KEY  ;
      }else{
      	__GLUW_ACS_keystat&=~(GLUW_CNTL_KEY)  ;
      }
      if (GetKeyState(VK_MENU) < 0){
      	__GLUW_ACS_keystat|=GLUW_ALT_KEY ;
      }else{
      	__GLUW_ACS_keystat&=~(GLUW_ALT_KEY) ;
      }
      if( gluw_mouse( __GLUW_ACS_keystat, __GLUW_mouseB, __GLUW_mouseX, __GLUW_mouseY )!=0 ){
	SendMessage( hWnd, WM_PAINT, 0, 0 ) ;
      }
    }
    //    printf("WM_MOUSEBUTTON\n") ;
    break ;
    
  case WM_CHAR:
    if( gluw_keyboard( LOBYTE(wp), __GLUW_mouseX, __GLUW_mouseY )!=0 ){
      SendMessage( hWnd, WM_PAINT, 0, 0 ) ;
    }
    printf("WM_CHAR %c\n",wp) ;
    break ;
    
  case WM_SYSCHAR:
    //    gluw_keyboard( LOBYTE(wp), __GLUW_mouseX, __GLUW_mouseY ) ;
    printf("WM_CHAR %c\n",wp) ;
    break ;
    
    //  case WM_KEYDOWN :
    //    if(      wp==VK_SHIFT   ) __GLUW_ACS_keystat|=GLUW_SHIFT_KEY ;
    //    else if( wp==VK_CONTROL ) __GLUW_ACS_keystat|=GLUW_CNTL_KEY  ;
    //    else return (DefWindowProc(hWnd, msg, wp, lp));
    //    //    printf("WM_KEYDOWN %08x\n",__GLUW_ACS_keystat) ;
    //    break ;
    //    
    //  case WM_SYSKEYDOWN :
    //    if(      wp==VK_MENU   ) __GLUW_ACS_keystat|=GLUW_ALT_KEY ;
    //    else return (DefWindowProc(hWnd, msg, wp, lp));
    //    printf("WM_SYSKEYDOWN %x\n",wp) ;
    //    break ;
    //    
    //  case WM_KEYUP :
    //    if(      wp==VK_SHIFT   ) __GLUW_ACS_keystat&=~(GLUW_SHIFT_KEY) ;
    //    else if( wp==VK_CONTROL ) __GLUW_ACS_keystat&=~(GLUW_CNTL_KEY)  ;
    //    else return (DefWindowProc(hWnd, msg, wp, lp));
    //    //    printf("WM_KEYUP %08x\n",__GLUW_ACS_keystat) ;
    //    break ;
    //    
    //  case WM_SYSKEYUP :
    //    if(      wp==VK_MENU   ) __GLUW_ACS_keystat&=~(GLUW_ALT_KEY) ;
    //    else return (DefWindowProc(hWnd, msg, wp, lp));
    //    printf("WM_SYSKEYUP %x\n",wp) ;
    //    break ;
    
  case WM_COMMAND:
    printf("WM_COMMAND\n") ;
    win_command(hWnd, msg, wp, lp) ;
    break;
    
  case WM_CLOSE:
    {
      int id;
      id = MessageBox(hWnd,
		      "IĂ낵ł",
		      "mF",
		      MB_YESNO | MB_ICONQUESTION);
      if (id == IDYES) {
	DestroyWindow(hWnd);
      }
    }
    break;
    
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
    
  default:
    return (DefWindowProc(hWnd, msg, wp, lp));
  }
  return(0);
}
